diff --git a/trunk/avrdude/avrdude.conf.in b/trunk/avrdude/avrdude.conf.in
index cae2a95..adf57ff 100644
--- a/trunk/avrdude/avrdude.conf.in
+++ b/trunk/avrdude/avrdude.conf.in
@@ -15093,26 +15093,198 @@ part
 ;
 
 #------------------------------------------------------------
-# ATtiny1617
+# ATtiny212
 #------------------------------------------------------------
 
-part parent ".avr8x"
-    id		= "tn1617";
-    desc	= "ATtiny1617";
-    signature	= 0x1e 0x94 0x20;
+part parent    ".avr8x"
+    id        = "tn212";
+    desc      = "ATtiny212";
+    signature = 0x1E 0x91 0x21;
+
+    memory "flash"
+        size      = 0x800;
+        offset    = 0x8000;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
 
     memory "eeprom"
-        size		= 0x0100;
-        offset		= 0x1400;
-        page_size	= 0x20;
-        readsize	= 0x100;
+        size      = 0x40;
+        offset    = 0x1400;
+        page_size = 0x20;
+        readsize  = 0x100;
     ;
+;
+
+#------------------------------------------------------------
+# ATtiny214
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "tn214";
+    desc      = "ATtiny214";
+    signature = 0x1E 0x91 0x20;
 
     memory "flash"
-        size		= 0x4000;
-        offset		= 0x8000;
-        page_size	= 0x40;
-        readsize	= 0x100;
+        size      = 0x800;
+        offset    = 0x8000;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x40;
+        offset    = 0x1400;
+        page_size = 0x20;
+        readsize  = 0x100;
+    ;
+;
+
+#------------------------------------------------------------
+# ATtiny412
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "tn412";
+    desc      = "ATtiny412";
+    signature = 0x1E 0x92 0x23;
+
+    memory "flash"
+        size      = 0x1000;
+        offset    = 0x8000;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x80;
+        offset    = 0x1400;
+        page_size = 0x20;
+        readsize  = 0x100;
+    ;
+;
+
+
+#------------------------------------------------------------
+# ATtiny414
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "tn414";
+    desc      = "ATtiny414";
+    signature = 0x1E 0x92 0x22;
+
+    memory "flash"
+        size      = 0x1000;
+        offset    = 0x8000;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x80;
+        offset    = 0x1400;
+        page_size = 0x20;
+        readsize  = 0x100;
+    ;
+;
+
+#------------------------------------------------------------
+# ATtiny416
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "tn416";
+    desc      = "ATtiny416";
+    signature = 0x1E 0x92 0x21;
+
+    memory "flash"
+        size      = 0x1000;
+        offset    = 0x8000;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x80;
+        offset    = 0x1400;
+        page_size = 0x20;
+        readsize  = 0x100;
+    ;
+;
+
+
+#------------------------------------------------------------
+# ATtiny417
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "tn417";
+    desc      = "ATtiny417";
+    signature = 0x1E 0x92 0x20;
+
+    memory "flash"
+        size      = 0x1000;
+        offset    = 0x8000;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x80;
+        offset    = 0x1400;
+        page_size = 0x20;
+        readsize  = 0x100;
+    ;
+;
+
+
+#------------------------------------------------------------
+# ATtiny814
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "tn814";
+    desc      = "ATtiny814";
+    signature = 0x1E 0x93 0x22;
+
+    memory "flash"
+        size      = 0x2000;
+        offset    = 0x8000;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x80;
+        offset    = 0x1400;
+        page_size = 0x20;
+        readsize  = 0x100;
+    ;
+;
+
+
+#------------------------------------------------------------
+# ATtiny816
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "tn816";
+    desc      = "ATtiny816";
+    signature = 0x1E 0x93 0x21;
+
+    memory "flash"
+        size      = 0x2000;
+        offset    = 0x8000;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x80;
+        offset    = 0x1400;
+        page_size = 0x20;
+        readsize  = 0x100;
     ;
 ;
 
@@ -15120,22 +15292,262 @@ part parent ".avr8x"
 # ATtiny817
 #------------------------------------------------------------
 
-part parent ".avr8x"
-    id		= "tn817";
-    desc	= "ATtiny817";
-    signature	= 0x1e 0x93 0x20;
+part parent    ".avr8x"
+    id        = "tn817";
+    desc      = "ATtiny817";
+    signature = 0x1E 0x93 0x20;
+
+    memory "flash"
+        size      = 0x2000;
+        offset    = 0x8000;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
 
     memory "eeprom"
-        size		= 0x0100;
-        offset		= 0x1400;
-        page_size	= 0x20;
-        readsize	= 0x100;
+        size      = 0x80;
+        offset    = 0x1400;
+        page_size = 0x20;
+        readsize  = 0x100;
     ;
+;
+
+#------------------------------------------------------------
+# ATtiny1614
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "tn1614";
+    desc      = "ATtiny1614";
+    signature = 0x1E 0x94 0x22;
 
     memory "flash"
-        size		= 0x2000;
-        offset		= 0x8000;
-        page_size	= 0x40;
-        readsize	= 0x100;
+        size      = 0x4000;
+        offset    = 0x8000;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x100;
+        offset    = 0x1400;
+        page_size = 0x20;
+        readsize  = 0x100;
+    ;
+;
+
+#------------------------------------------------------------
+# ATtiny1616
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "tn1616";
+    desc      = "ATtiny1616";
+    signature = 0x1E 0x94 0x21;
+
+    memory "flash"
+        size      = 0x4000;
+        offset    = 0x8000;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x100;
+        offset    = 0x1400;
+        page_size = 0x20;
+        readsize  = 0x100;
+    ;
+;
+
+#------------------------------------------------------------
+# ATtiny1617
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "tn1617";
+    desc      = "ATtiny1617";
+    signature = 0x1E 0x94 0x20;
+
+    memory "flash"
+        size      = 0x4000;
+        offset    = 0x8000;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x100;
+        offset    = 0x1400;
+        page_size = 0x20;
+        readsize  = 0x100;
+    ;
+;
+
+#------------------------------------------------------------
+# ATtiny3214
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "tn3214";
+    desc      = "ATtiny3214";
+    signature = 0x1E 0x95 0x20;
+
+    memory "flash"
+        size      = 0x8000;
+        offset    = 0x8000;
+        page_size = 0x80;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x100;
+        offset    = 0x1400;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+;
+
+#------------------------------------------------------------
+# ATtiny3216
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "tn3216";
+    desc      = "ATtiny3216";
+    signature = 0x1E 0x95 0x21;
+
+    memory "flash"
+        size      = 0x8000;
+        offset    = 0x8000;
+        page_size = 0x80;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x100;
+        offset    = 0x1400;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+;
+
+#------------------------------------------------------------
+# ATtiny3217
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "tn3217";
+    desc      = "ATtiny3217";
+    signature = 0x1E 0x95 0x22;
+
+    memory "flash"
+        size      = 0x8000;
+        offset    = 0x8000;
+        page_size = 0x80;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x100;
+        offset    = 0x1400;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+;
+
+#------------------------------------------------------------
+# ATmega3208
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "m3208";
+    desc      = "ATmega3208";
+    signature = 0x1E 0x95 0x52;
+
+    memory "flash"
+        size      = 0x8000;
+        offset    = 0x4000;
+        page_size = 0x80;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x100;
+        offset    = 0x1400;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+;
+
+#------------------------------------------------------------
+# ATmega3209
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "m3209";
+    desc      = "ATmega3209";
+    signature = 0x1E 0x95 0x53;
+
+    memory "flash"
+        size      = 0x8000;
+        offset    = 0x4000;
+        page_size = 0x80;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x100;
+        offset    = 0x1400;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+;
+
+#------------------------------------------------------------
+# ATmega4808
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "m4808";
+    desc      = "ATmega4808";
+    signature = 0x1E 0x96 0x50;
+
+    memory "flash"
+        size      = 0xC000;
+        offset    = 0x4000;
+        page_size = 0x80;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x100;
+        offset    = 0x1400;
+        page_size = 0x40;
+        readsize  = 0x100;
+    ;
+;
+
+#------------------------------------------------------------
+# ATmega4809
+#------------------------------------------------------------
+
+part parent    ".avr8x"
+    id        = "m4809";
+    desc      = "ATmega4809";
+    signature = 0x1E 0x96 0x51;
+
+    memory "flash"
+        size      = 0xC000;
+        offset    = 0x4000;
+        page_size = 0x80;
+        readsize  = 0x100;
+    ;
+
+    memory "eeprom"
+        size      = 0x100;
+        offset    = 0x1400;
+        page_size = 0x40;
+        readsize  = 0x100;
     ;
 ;